crashpad::internal::MinidumpModuleCodeViewRecordPDBLinkWriter< CodeViewRecordType > Class Template Reference

The base class for writers of CodeView records that serve as links to `.pdb` (program database) files. More...

`#include "minidump/minidump_module_writer.h"`

Inheritance diagram for crashpad::internal::MinidumpModuleCodeViewRecordPDBLinkWriter< CodeViewRecordType >:

## Public Member Functions

void | SetPDBName (const std::string &pdb_name)
| Sets the name of the `.pdb` file being linked to.
Public Member Functions inherited from crashpad::internal::MinidumpWritable
virtual bool | WriteEverything (FileWriterInterface *file_writer)
| Writes an object and all of its children to a minidump file. More...
void | RegisterRVA (RVA *rva)
| Registers a file offset pointer as one that should point to the object on which this method is called. More...
void | RegisterLocationDescriptor (MINIDUMP_LOCATION_DESCRIPTOR *location_descriptor)
| Registers a location descriptor as one that should point to the object on which this method is called. More...

## Protected Member Functions

size_t | SizeOfObject () override
| Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment. More...
bool | WriteObject (FileWriterInterface *file_writer) override
| Writes the object’s content. More...
CodeViewRecordType * | codeview_record ()
| Returns a pointer to the raw CodeView record’s data. More...
Protected Member Functions inherited from crashpad::internal::MinidumpWritable
State | state () const
| The state of the object.
virtual bool | Freeze ()
| Transitions the object from kStateMutable to kStateFrozen. More...
virtual size_t | Alignment ()
| Returns the object’s desired byte-boundary alignment. More...
virtual std::vector< MinidumpWritable * > | Children ()
| Returns the object’s children. More...
virtual Phase | WritePhase ()
| Returns the object’s desired write phase. More...
size_t | WillWriteAtOffset (Phase phase, FileOffset *offset, std::vector< MinidumpWritable *> *write_sequence)
| Prepares the object to be written at a known file offset, transitioning it from kStateFrozen to kStateWritable. More...
virtual bool | WillWriteAtOffsetImpl (FileOffset offset)
| Called once an object’s writable file offset is determined, as it transitions into kStateWritable. More...
bool | WritePaddingAndObject (FileWriterInterface *file_writer)
| Writes the object, transitioning it from kStateWritable to kStateWritten. More...

## Additional Inherited Members

Protected Types inherited from crashpad::internal::MinidumpWritable
enum | State
| Identifies the state of an object. More...
enum | Phase
| Identifies the phase during which an object will be written to a minidump file. More...
Static Protected Attributes inherited from crashpad::internal::MinidumpWritable
static constexpr size_t | kInvalidSize = std::numeric_limits<size_t>::max()
| A size value used to signal failure by methods that return `size_t`.

## Detailed Description

### template<typename CodeViewRecordType>
class crashpad::internal::MinidumpModuleCodeViewRecordPDBLinkWriter< CodeViewRecordType >

The base class for writers of CodeView records that serve as links to `.pdb` (program database) files.

## Member Function Documentation

## codeview_record()

template<typename CodeViewRecordType>

CodeViewRecordType* crashpad::internal::MinidumpModuleCodeViewRecordPDBLinkWriter< CodeViewRecordType >::codeview_record | ( |  | ) |

inlineprotected

Returns a pointer to the raw CodeView record’s data.

Subclasses can use this to set fields in their codeview records other than the `pdb_name` field.

## SizeOfObject()

template<typename CodeViewRecordType >

size_t crashpad::internal::MinidumpModuleCodeViewRecordPDBLinkWriter< CodeViewRecordType >::SizeOfObject | ( |  | ) |

overrideprotectedvirtual

Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment.

Note
  Valid in kStateFrozen or any subsequent state.

Implements crashpad::internal::MinidumpWritable.

## WriteObject()

template<typename CodeViewRecordType >

bool crashpad::internal::MinidumpModuleCodeViewRecordPDBLinkWriter< CodeViewRecordType >::WriteObject | ( | FileWriterInterface * | file_writer | ) |

overrideprotectedvirtual

Writes the object’s content.

Parameters

  [in] | file_writer | The file writer to receive the object’s content.

Returns
  `true` on success. `false` on error, indicating that the content could not be written to the minidump file.

Note
  Valid in kStateWritable. The object will transition to kStateWritten after this method returns.

Implements crashpad::internal::MinidumpWritable.

The documentation for this class was generated from the following files:

- minidump/minidump_module_writer.h
- minidump/minidump_module_writer.cc